


goal Arith.thy 
     "! B K H T oplus n f.  \
     \    (! x y z. (oplus (oplus x y) z = oplus x (oplus y z))   \
     \    & (! x. oplus x n = x ) )                               \
     \    --> ( (! x. f x= (if (B x) then f (oplus (H x) (K x))   \
     \                           else T x))                       \
     \        = ((! x. f x = g x n) &                             \
     \           (! x. (g x y) = (if (B x) then g (H x) (oplus (K x) y)   \
     \                                 else (oplus (T x) y)))))"



fun LINTAIL n [B, K, H, T, oplus, n, f] _ =
    let  (* grab signature in which the parameters were parsed *)
        val sg = (#sign(rep_thm(topthm())));

        fun intro_param str th = 
                th RS (read_instantiate_sg sg [("x",str)] spec);

        (* parse and instantiate parameters *)
        val it = intro_param B lintail_def
        val it = intro_param K it
        val it = intro_param H it
        val it = intro_param T it
        val it = intro_param oplus it
        val it = intro_param n it
        val it = intro_param f it

        (* convert applicability condition into meta-hypothesis *)
        (* and strips of output-pattern                         *)
        val it = (it RS mp) RS subst;

   in EVERY [rtac it i,
             rtac conjI i]
   end
