(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/isa_toolkit/html.sml,v $
 
   HTML support. 
  
   $Date: 1997/09/01 11:44:38 $
   $Revision: 1.5 $
   Author: cxl (Last modification by $Author: cxl $)
 
   (C) 1997, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)
 
structure HTML :
    sig
	type url
	type html

	val display : html-> unit
	val openURL : url-> unit

	val mkHtml  : string* string-> html

    end = 

struct

    open TkTypes SmlTk

    datatype html = mkHtml of string* string
    type url = string

    fun mozilla cmd arg =
	ignore 
	(OS.Process.system ("netscape -raise -remote '"^cmd^"("^arg^")'"))
	handle (OS.SysErr (err, _)) 
	=> (* utilWin.error ("Error: "^err^"\nCan't run HTML browser.\n")
	      (K()) *)
	   Debug.warning ("Error: "^err^"-- can't run HTML browser.\n")
	   
	    
    val openURL = mozilla "openURL"
	
    fun display (mkHtml(title, body)) =	    
	let open TextIO OS
	    val str= "<HTML><HEADER><TITLE>"^title^"</TITLE></HEADER>\n"^
		"<BODY BGCOLOR =\"#FFFFFF\" text=\"000000\" LINK=\"#0000FF\" ALINK=\"#00CC00\" VLINK=\"#000099\">"^body^"</BODY></HTML>\n"
	    val tmpFile= "/tmp/TAS"^(newWinId())
	    val out= openOut(tmpFile)
	in  (output(out, str);
	     closeOut(out);
	     mozilla "openURL" ("file:"^tmpFile)   
	                        (* netscape4 disnae know openFile anymore ?! *)
	     (* remove tmpFile here ?!? *)
	     )
	end   
	

end
