
(* lex example *)


lex =  String   +



datatype RegEXP_type	=  "eREG" ("eREG") 
                 | mkREG  char        
                 | uREG   RegEXP_type    (RegEXP_type)  (*(infixr 65) *)
                 | comREG RegEXP_type    (RegEXP_type) (*(infixr 65) *)
                 | pREG   RegEXP_type


arities
RegEXP_type ::term

types
token       = "string * RegEXP_type "
config      = "string * RegEXP_type list" 

 
consts
LongestMatch ::"[token, config]            => bool"("_ longestM _"[100,101]100) 
LongerMatch  ::"[token, config * token]    => bool"("_ longerM _"[100,101]100) 
PrefixMatch  ::"[token, config ]           => bool"("_ prefixM _"[100,101]100) 
Scan         ::"config                     => config"
NextMatch    ::"[RegEXP_type list, config] => config"
matches      ::"[string,  RegEXP_type]     => bool"( "_ matches _" [100,101]100)
pos          ::"'a * 'a list => nat"


rules
 
matchesEmpty "s matches eREG           == (s = [])" 
matchesChar  "s matches mkREG c        == (s = ''c'' )" 
matchesComp  "s matches (comREG r1 r2) == ((s matches r1) | (s matches r2))" 
matchesUnion "s matches (uREG r1 r2)   ==  ? s1 s2. s1 @ s2 = s & 
                                              s matches r1 & s matches r2" 
matchesPow   "s matches pREG r1        == (s=[]
                                            | s matches (comREG r1 (pREG r1)))"


IsPrefixM "(s1, r) prefixM (s2, rs) == r mem rs & s2 = s @ s1 &
                                                      s1 matches r"

IsLonger " (s1, r1) longerM ((s, rs), (s2, r2)) == (length s2 < length s1) |  
                                                  (length s2 = length s1) & 
                                                  (pos(r1, rs) < pos(r, rs))"

IsLongest "(s1, r) longestM (s2, rs) = (s1, r1) prefixM (s, rs)  &
                                        (ALL s2 r2. (s1, r1) ~= (s2, r2) &
                                         (s2, r2) prefixM (s, rs)  -->
                                        ((s1, r1) longerM ((s, rs), (s2, r2))))"

SCAN "(ALL R S. (R = Scan S) -->                                                
                           (EX st rs2 ds dst st1.
                               ((flat st) @ fst S) = fst R &
                               length (snd S) = length st &
                                st ~= [] -->
                               (ALL j.
                                    1 < j & j < (length (snd S)) &
                                   nth j st ~= [] &
                                   st1 = nth j st &
                                   rs2 = nth j (snd S) &
                                   ds = flat (drop j st) &
                                   dst =  (ds @ (fst S)) &
                                   ((st1, rs2) longestM (dst, (snd R))))) &
                           (ALL r2 s2.
                                 (s2, r2) prefixM (fst S, snd R)) --> s2 = [])"


NextMatch_d
    "(NextMatch rs (s1,rs1)) = (s2,rs2) =
                     (ALL s1 s2 rs rs1 rs2.                        
                         (EX s3.
                             s1 = s3 @ s2) &
                             s3 ~= [] &
                             (EX r.
                                 rs2 =  (rs1@[r]) &
                                 (s3, r) prefixM (s1, rs)) &
      (NextMatch rs (s1,rs1)) = (s1,rs1) =
                         (~(EX s3.
                             s1 = s3 @ s2) &
                             s3 ~= [] &
                             (EX r.
                                 rs2 =  (rs1@[r]) &
                                 (s3, r) prefixM (s1, rs))))"


end
