(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1996/06/19 11:53:57 $
  $Revision: 1.1 $
   Purpose of this file: Functions related to TkEvents

   *********************************************************************** *)

signature TK_EVENT =
    sig
	open BasicTypes

	val selButton   : TkEvent -> int
	val selState    : TkEvent -> string
	val selXPos     : TkEvent -> int
	val selYPos     : TkEvent -> int
	val selXRootPos : TkEvent -> int
	val selYRootPos : TkEvent -> int

	val show    : unit   -> string
	val unparse : string -> TkEvent
    end
