open DivideNConquer;

(* Types of divideNconquer:

"! (isPrim::?'a::term => bool) (Dir::?'a::term => ?'b::term)
      (Com::?'c::term * ?'b::term => ?'b::term) (G::?'d::term => ?'c::term)
      Decom::?'a::term => ?'d::term * ?'a::term.
      (? less::(?'a::term * ?'a::term) set.
          wf less &
          (! (x0::?'a::term) (x1::?'d::term) x2::?'a::term.
              Decom x0 = (x1, x2) -->
              (?In::?'a::term => bool) x0 & ~ isPrim x0 -->
              ?In x2 & (x2, x0) : less) &
          (! x::?'a::term.
              isPrim x & ?In x -->
              (?Out::?'a::term * ?'b::term => bool) (x, Dir x)) &
          (! (x0::?'a::term) (x1::?'d::term) (x2::?'a::term) (z0::?'b::term)
              z2::?'b::term.
              Decom x0 = (x1, x2) & ?Out (x2, z2) & Com (G x1, z2) = z0 -->
              ?Out (?x::?'a::term, z0))) -->
      (?In ?x -->
       ?Out (?x, ?z::?'b::term) & (?F::?'a::term => ?'b::term) ?x = ?z) =
      (?In ?x -->
       ?Out (?x, ?F ?x) &
       ?F ?x =
       (if isPrim ?x then Dir ?x else (Com o prod_fun G ?F o Decom) ?x))"
       
*)

goal thy "true --> sort x = y & ((is_perm x y) & asc (y))";



(* Einfacher insert-sort. Quadratischer Aufwand.
insert a X = list_rec (%a. a) 
		      (%x xs r. %a. if a <= x then a#x#xs else x#(r a))
		      a

isPrim |-> (%xs. xs = [])
Dir    |-> (%x.x)
Decom  |-> (%x. (hd x, tl x))
G      |-> (%x.x) 
Com    |-> (%(x,xs). insert x xs)
*)

(* merge_sort. logarithmischer aufwand (im prinzip)...

isPrim |-> (%xs. xs = [])
Dir    |-> (%x.x)
Decom  |-> (%x.(filter (%y. y <= (hd x)) x, filter (%y.~(y <= (hd x))) x))
G      |-> (%x. F x) 
Com    |-> (%(x,y). x @ y)

*)




