(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1997/03/21 17:51:28 $
  $Revision: 1.2 $
   Purpose of this file: Abstract data Type Window

   *********************************************************************** *)

signature WINDOW =
    sig
	open BasicTypes

	val check      : Window -> bool

	val checkWinId : WinId  -> bool
	val checkTitle : Title  -> bool

(*
	val appendGUI    : Window -> unit
	val addGUI       : Window -> unit
	val deleteGUI    : WinId -> unit	
	val deleteAllGUI : unit -> unit
*)

	val changeTitle : WinId -> Title -> unit
	val openW       : Window -> unit
	val close       : WinId -> unit

    end
